package ${basePackage}.${packageName}.dao.mapper;

import ${basePackage}.${packageName}.domain.po.${className};
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* @title: ${tableComments}持久层业务处理
* @Description 此处仅涉及复杂SQL操作，务必不要在此再次写单表的CRUD操作，因为mybatisPlus已经实现。
* @company: hugeinfo
* @author: ${author}
* @time: ${createTime}
* @version ${version}
*/
@Repository
public interface ${className}Mapper extends BaseMapper<${className}>{

    /**
    * 更新对象
    * @param entity 对象
    */
    void update${className}(@Param("entity") ${className} entity);

    /**
    * 条件更新对象
    * @param entity 对象
    * @param terms 条件
    */
    void update${className}Terms(@Param("entity") ${className} entity, @Param("terms") Map<String, Object> terms);

    /**
    * 根据编号物理删除
    * @param id 查询条件集合
    */
    void delete${className}(@Param("id") String id);

    /**
    * 按条件查询结果集
    * @param terms 查询条件集合
    * @return List<${className}>
    */
    List<${className}> listTerms(@Param("terms") Map<String, Object> terms);

    /**
    * 按条件查询实体总数
    * @param terms 查询条件集合
    * @return long
    */
    long countTerms(@Param("terms") Map<String, Object> terms);

    /**
    * 按条件查询实体分页结果集
    * @param page 分页对象
    * @param terms 查询条件集合
    * @return List<${className}>
    */
    List<${className}> pageTerms(@Param("page") PageRequest page, @Param("terms") Map<String, Object> terms);

}
